// 12.02.2020
// Alle Funksteckdosen zu Programmstart "AUS"
// Einstellung Arduino IDE: Node MCU 1.0,ESP-12E
#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <RCSwitch.h>
#include "index_html.h"  // In dieser Datei befindet sich die Steuerung Webseite

RCSwitch mySwitch = RCSwitch();

const char* ssid = "deine-ssid";          // WLAN-Name in "" !
const char* password = "dein-password";   // WLAN-Passwort in ""!

#define LED 2           // LED GPIO 2

ESP8266WebServer server(80);// Serverport  hier einstellen

int val1 = 0; 	        // Hier wird der Schaltzustand "Schalter 1" gespeichert
int val2 = 0;           // Hier wird der Schaltzustand "Schalter 2" gespeichert
int val3 = 0;           // Hier wird der Schaltzustand "Schalter 3" gespeichert
int val4 = 0;           // Hier wird der Schaltzustand "Schalter 4" gespeichert

String fsd1;
String fsd2;
String fsd3;
String fsd4;


void setup()
{
   
  mySwitch.enableTransmit(4); // 433MHz-Sender ist verbunden mit GPIO 4 /D2 
  
  IPAddress ip(192, 168, 178, 240);            // IP - Adresse ESP 8266 / ESP-12E
  IPAddress gateway(192, 168, 178, 1);         // IP - Adresse Router
  IPAddress subnet(255, 255, 255, 0);
  IPAddress dns(192, 168, 178, 1);             // im der Regel auch IP - Adresse Router
  WiFi.config(ip, dns, gateway, subnet);
  
  pinMode (LED, OUTPUT); 
 
  // Mit Haus WLAN Verbinden
  digitalWrite(LED, HIGH); //Led port ausschalten
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
   
  // Warte auf verbindung
  while (WiFi.status() != WL_CONNECTED)
    {
    delay(500);
    }
  // ENDE Mit Haus WLAN Verbinden
   
  //  Bechandlung der Ereignissen anschliessen
  server.on("/", Ereignis_Index);
  server.onNotFound ( handleNotFound );
  server.begin();  			  // Starte den Server

   
  digitalWrite(LED, LOW); //Led port einschalten, WLAN-Verbindung hergestellt
  delay(500);
  digitalWrite(LED, HIGH); //Led port ausschalten
  delay(500);
  digitalWrite(LED, LOW); //Led port einschalten


 // Alls Steckdosen "AUS"
  mySwitch.switchOff("10001", "10000"); // PrimärCode, SekundärCode -> Steckdose "A" 
  mySwitch.switchOff("10001", "01000"); // PrimärCode, SekundärCode -> Steckdose "B"
  mySwitch.switchOff("10001", "00100"); // PrimärCode, SekundärCode -> Steckdose "C"
  mySwitch.switchOff("10001", "00010"); // PrimärCode, SekundärCode -> Steckdose "D"
}

void loop()

{
  server.handleClient();
}

void Ereignis_Index()    // Wird ausgeführt wenn "http://<ip address>/" aufgerufen wurde
{
  if (server.args() > 0) // wenn Argumente im GET Anfrage vorhanden sind z.B http://<ip address>/?zustand=r
  {
    // Funksteckdose "A"
   if (server.arg("relais") == "1")  // prüfen ob "/?relais=1"  Toggle Funktion
    {     
     val1 = !val1;                     // Umschalten
      if (val1 == 1) 
      {
        mySwitch.switchOn("10001", "10000"); // PrimärCode, SekundärCode -> Steckdose "A"
      }
      if (val1 == 0) 
      {
        mySwitch.switchOff("10001", "10000"); // PrimärCode, SekundärCode -> Steckdose "A"
      }       
      fsd1 = String(int(val1));
   }
    // Funksteckdose "B"
    if (server.arg("relais") == "2")  // prüfen ob "/?relais=2"  Toggle Funktion
    {     
     val2 = !val2;                     // Umschalten
      if (val2 == 1) 
      {
        mySwitch.switchOn("10001", "01000"); // PrimärCode, SekundärCode -> Steckdose "B"
      }
      if (val2 == 0) 
      {
        mySwitch.switchOff("10001", "01000"); // PrimärCode, SekundärCode -> Steckdose "B"
      }        
      fsd2 = String(int(val2));
    }
     // Funksteckdose "C"
    if (server.arg("relais") == "3")  // prüfen ob "/?relais=3"  Toggle Funktion
    {            
     val3 = !val3;                     // Umschalten
      if (val3 == 1) 
      {
        mySwitch.switchOn("10001", "00100"); // PrimärCode, SekundärCode -> Steckdose "C"
      }
      if (val3 == 0) 
      {
        mySwitch.switchOff("10001", "00100"); // PrimärCode, SekundärCode -> Steckdose "C"
      }       
      fsd3 = String(int(val3));
    }
    // Funksteckdose "D"
    if (server.arg("relais") == "4")  // prüfen ob "/?relais=4"  Toggle Funktion
    {        
     val4 = !val4;                     // Umschalten
      if (val4 == 1) 
      {
        mySwitch.switchOn("10001", "00010"); // PrimärCode, SekundärCode -> Steckdose "D"
      }
      if (val4 == 0) 
      {
        mySwitch.switchOff("10001", "00010"); // PrimärCode, SekundärCode -> Steckdose "D"
      }         
      fsd4 = String(int(val4));
    } 
       
    // es wird immer Schalt - Zustand mitgeteilt
    server.sendHeader("Cache-Control", "no-cache");     // wichtig! damit Daten nicht aus dem Browser cach kommen
    server.send(200, "text/plain", (fsd1 + fsd2 + fsd3 + fsd4));        // Antwort an Internet Browser: Sendet 4 Zahlen ("0"/"1").
   }
  else        // wenn keine Argumente im GET Anfrage
  {
    //("Sende Index.html");
    server.send(200, "text/html", indexHTML);           //dann Index Webseite senden (siehe Datei "index_html.h")
  }
  delay(50);
}

void handleNotFound()
{
  server.send(404, "text/plain", "404: Not found");     // Send HTTP status 404 (Not Found)
}
